# coding: utf-8

"""
    Corellium API

    REST API to manage your virtual devices.  # noqa: E501

    The version of the OpenAPI document: 7.3.0
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from corellium_api.configuration import Configuration


class CreateNetworkConnectionOptions(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'identifier': 'str',
        'name': 'str',
        'provider': 'str',
        'config': 'object'
    }

    attribute_map = {
        'identifier': 'identifier',
        'name': 'name',
        'provider': 'provider',
        'config': 'config'
    }

    def __init__(self, identifier=None, name=None, provider=None, config=None, local_vars_configuration=None):  # noqa: E501
        """CreateNetworkConnectionOptions - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._identifier = None
        self._name = None
        self._provider = None
        self._config = None
        self.discriminator = None

        self.identifier = identifier
        self.name = name
        self.provider = provider
        self.config = config

    @property
    def identifier(self):
        """Gets the identifier of this CreateNetworkConnectionOptions.  # noqa: E501

        UUIDv4  # noqa: E501

        :return: The identifier of this CreateNetworkConnectionOptions.  # noqa: E501
        :rtype: str
        """
        return self._identifier

    @identifier.setter
    def identifier(self, identifier):
        """Sets the identifier of this CreateNetworkConnectionOptions.

        UUIDv4  # noqa: E501

        :param identifier: The identifier of this CreateNetworkConnectionOptions.  # noqa: E501
        :type identifier: str
        """
        if self.local_vars_configuration.client_side_validation and identifier is None:  # noqa: E501
            raise ValueError("Invalid value for `identifier`, must not be `None`")  # noqa: E501

        self._identifier = identifier

    @property
    def name(self):
        """Gets the name of this CreateNetworkConnectionOptions.  # noqa: E501

        User specified name for this network connection. e.g. My Network Connection  # noqa: E501

        :return: The name of this CreateNetworkConnectionOptions.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CreateNetworkConnectionOptions.

        User specified name for this network connection. e.g. My Network Connection  # noqa: E501

        :param name: The name of this CreateNetworkConnectionOptions.  # noqa: E501
        :type name: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def provider(self):
        """Gets the provider of this CreateNetworkConnectionOptions.  # noqa: E501

        One of the registered [network provider types](#get-/v1/network/providers)  # noqa: E501

        :return: The provider of this CreateNetworkConnectionOptions.  # noqa: E501
        :rtype: str
        """
        return self._provider

    @provider.setter
    def provider(self, provider):
        """Sets the provider of this CreateNetworkConnectionOptions.

        One of the registered [network provider types](#get-/v1/network/providers)  # noqa: E501

        :param provider: The provider of this CreateNetworkConnectionOptions.  # noqa: E501
        :type provider: str
        """
        if self.local_vars_configuration.client_side_validation and provider is None:  # noqa: E501
            raise ValueError("Invalid value for `provider`, must not be `None`")  # noqa: E501

        self._provider = provider

    @property
    def config(self):
        """Gets the config of this CreateNetworkConnectionOptions.  # noqa: E501

        An object containing network connection configuration data. Will vary based on network provider type. See examples.  # noqa: E501

        :return: The config of this CreateNetworkConnectionOptions.  # noqa: E501
        :rtype: object
        """
        return self._config

    @config.setter
    def config(self, config):
        """Sets the config of this CreateNetworkConnectionOptions.

        An object containing network connection configuration data. Will vary based on network provider type. See examples.  # noqa: E501

        :param config: The config of this CreateNetworkConnectionOptions.  # noqa: E501
        :type config: object
        """

        self._config = config

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateNetworkConnectionOptions):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateNetworkConnectionOptions):
            return True

        return self.to_dict() != other.to_dict()
