# coding: utf-8

"""
    Corellium API

    REST API to manage your virtual devices.  # noqa: E501

    The version of the OpenAPI document: 7.3.0
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from corellium_api.configuration import Configuration


class DomainAuthProviderResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'identifier': 'str',
        'id': 'str',
        'provider_type': 'str',
        'provider': 'str',
        'label': 'str',
        'name': 'str',
        'authorization_url': 'str',
        'default': 'bool',
        'enabled': 'bool',
        'config': 'OpenIDConfig',
        'created_by': 'str',
        'created_at': 'str',
        'updated_at': 'str'
    }

    attribute_map = {
        'identifier': 'identifier',
        'id': 'id',
        'provider_type': 'providerType',
        'provider': 'provider',
        'label': 'label',
        'name': 'name',
        'authorization_url': 'authorizationUrl',
        'default': 'default',
        'enabled': 'enabled',
        'config': 'config',
        'created_by': 'createdBy',
        'created_at': 'createdAt',
        'updated_at': 'updatedAt'
    }

    def __init__(self, identifier=None, id=None, provider_type=None, provider=None, label=None, name=None, authorization_url=None, default=None, enabled=None, config=None, created_by=None, created_at=None, updated_at=None, local_vars_configuration=None):  # noqa: E501
        """DomainAuthProviderResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._identifier = None
        self._id = None
        self._provider_type = None
        self._provider = None
        self._label = None
        self._name = None
        self._authorization_url = None
        self._default = None
        self._enabled = None
        self._config = None
        self._created_by = None
        self._created_at = None
        self._updated_at = None
        self.discriminator = None

        self.identifier = identifier
        self.id = id
        self.provider_type = provider_type
        self.provider = provider
        self.label = label
        self.name = name
        self.authorization_url = authorization_url
        self.default = default
        self.enabled = enabled
        if config is not None:
            self.config = config
        self.created_by = created_by
        self.created_at = created_at
        self.updated_at = updated_at

    @property
    def identifier(self):
        """Gets the identifier of this DomainAuthProviderResponse.  # noqa: E501

        Provider ID  # noqa: E501

        :return: The identifier of this DomainAuthProviderResponse.  # noqa: E501
        :rtype: str
        """
        return self._identifier

    @identifier.setter
    def identifier(self, identifier):
        """Sets the identifier of this DomainAuthProviderResponse.

        Provider ID  # noqa: E501

        :param identifier: The identifier of this DomainAuthProviderResponse.  # noqa: E501
        :type identifier: str
        """
        if self.local_vars_configuration.client_side_validation and identifier is None:  # noqa: E501
            raise ValueError("Invalid value for `identifier`, must not be `None`")  # noqa: E501

        self._identifier = identifier

    @property
    def id(self):
        """Gets the id of this DomainAuthProviderResponse.  # noqa: E501

        Provider ID for backward compatibility with frontend  # noqa: E501

        :return: The id of this DomainAuthProviderResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DomainAuthProviderResponse.

        Provider ID for backward compatibility with frontend  # noqa: E501

        :param id: The id of this DomainAuthProviderResponse.  # noqa: E501
        :type id: str
        """

        self._id = id

    @property
    def provider_type(self):
        """Gets the provider_type of this DomainAuthProviderResponse.  # noqa: E501

        Provider Type  # noqa: E501

        :return: The provider_type of this DomainAuthProviderResponse.  # noqa: E501
        :rtype: str
        """
        return self._provider_type

    @provider_type.setter
    def provider_type(self, provider_type):
        """Sets the provider_type of this DomainAuthProviderResponse.

        Provider Type  # noqa: E501

        :param provider_type: The provider_type of this DomainAuthProviderResponse.  # noqa: E501
        :type provider_type: str
        """
        if self.local_vars_configuration.client_side_validation and provider_type is None:  # noqa: E501
            raise ValueError("Invalid value for `provider_type`, must not be `None`")  # noqa: E501

        self._provider_type = provider_type

    @property
    def provider(self):
        """Gets the provider of this DomainAuthProviderResponse.  # noqa: E501

        Provider Type for backward compatibility with frontend  # noqa: E501

        :return: The provider of this DomainAuthProviderResponse.  # noqa: E501
        :rtype: str
        """
        return self._provider

    @provider.setter
    def provider(self, provider):
        """Sets the provider of this DomainAuthProviderResponse.

        Provider Type for backward compatibility with frontend  # noqa: E501

        :param provider: The provider of this DomainAuthProviderResponse.  # noqa: E501
        :type provider: str
        """

        self._provider = provider

    @property
    def label(self):
        """Gets the label of this DomainAuthProviderResponse.  # noqa: E501

        Login Button Text  # noqa: E501

        :return: The label of this DomainAuthProviderResponse.  # noqa: E501
        :rtype: str
        """
        return self._label

    @label.setter
    def label(self, label):
        """Sets the label of this DomainAuthProviderResponse.

        Login Button Text  # noqa: E501

        :param label: The label of this DomainAuthProviderResponse.  # noqa: E501
        :type label: str
        """
        if self.local_vars_configuration.client_side_validation and label is None:  # noqa: E501
            raise ValueError("Invalid value for `label`, must not be `None`")  # noqa: E501

        self._label = label

    @property
    def name(self):
        """Gets the name of this DomainAuthProviderResponse.  # noqa: E501

        Title Text for the Frontend's Provider Configuration Form  # noqa: E501

        :return: The name of this DomainAuthProviderResponse.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DomainAuthProviderResponse.

        Title Text for the Frontend's Provider Configuration Form  # noqa: E501

        :param name: The name of this DomainAuthProviderResponse.  # noqa: E501
        :type name: str
        """

        self._name = name

    @property
    def authorization_url(self):
        """Gets the authorization_url of this DomainAuthProviderResponse.  # noqa: E501

        Coordinator endpoint for Authorizing with this provider  # noqa: E501

        :return: The authorization_url of this DomainAuthProviderResponse.  # noqa: E501
        :rtype: str
        """
        return self._authorization_url

    @authorization_url.setter
    def authorization_url(self, authorization_url):
        """Sets the authorization_url of this DomainAuthProviderResponse.

        Coordinator endpoint for Authorizing with this provider  # noqa: E501

        :param authorization_url: The authorization_url of this DomainAuthProviderResponse.  # noqa: E501
        :type authorization_url: str
        """

        self._authorization_url = authorization_url

    @property
    def default(self):
        """Gets the default of this DomainAuthProviderResponse.  # noqa: E501

        True: Configured in coordinator.json, False: Custom Domain Provider  # noqa: E501

        :return: The default of this DomainAuthProviderResponse.  # noqa: E501
        :rtype: bool
        """
        return self._default

    @default.setter
    def default(self, default):
        """Sets the default of this DomainAuthProviderResponse.

        True: Configured in coordinator.json, False: Custom Domain Provider  # noqa: E501

        :param default: The default of this DomainAuthProviderResponse.  # noqa: E501
        :type default: bool
        """
        if self.local_vars_configuration.client_side_validation and default is None:  # noqa: E501
            raise ValueError("Invalid value for `default`, must not be `None`")  # noqa: E501

        self._default = default

    @property
    def enabled(self):
        """Gets the enabled of this DomainAuthProviderResponse.  # noqa: E501

        Enabled/Disabled  # noqa: E501

        :return: The enabled of this DomainAuthProviderResponse.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this DomainAuthProviderResponse.

        Enabled/Disabled  # noqa: E501

        :param enabled: The enabled of this DomainAuthProviderResponse.  # noqa: E501
        :type enabled: bool
        """
        if self.local_vars_configuration.client_side_validation and enabled is None:  # noqa: E501
            raise ValueError("Invalid value for `enabled`, must not be `None`")  # noqa: E501

        self._enabled = enabled

    @property
    def config(self):
        """Gets the config of this DomainAuthProviderResponse.  # noqa: E501


        :return: The config of this DomainAuthProviderResponse.  # noqa: E501
        :rtype: OpenIDConfig
        """
        return self._config

    @config.setter
    def config(self, config):
        """Sets the config of this DomainAuthProviderResponse.


        :param config: The config of this DomainAuthProviderResponse.  # noqa: E501
        :type config: OpenIDConfig
        """

        self._config = config

    @property
    def created_by(self):
        """Gets the created_by of this DomainAuthProviderResponse.  # noqa: E501

        Optional User ID of creator  # noqa: E501

        :return: The created_by of this DomainAuthProviderResponse.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this DomainAuthProviderResponse.

        Optional User ID of creator  # noqa: E501

        :param created_by: The created_by of this DomainAuthProviderResponse.  # noqa: E501
        :type created_by: str
        """

        self._created_by = created_by

    @property
    def created_at(self):
        """Gets the created_at of this DomainAuthProviderResponse.  # noqa: E501

        Created Date in ISO-8601 format e.g. 2022-05-06T02:39:23.000Z  # noqa: E501

        :return: The created_at of this DomainAuthProviderResponse.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this DomainAuthProviderResponse.

        Created Date in ISO-8601 format e.g. 2022-05-06T02:39:23.000Z  # noqa: E501

        :param created_at: The created_at of this DomainAuthProviderResponse.  # noqa: E501
        :type created_at: str
        """
        if self.local_vars_configuration.client_side_validation and created_at is None:  # noqa: E501
            raise ValueError("Invalid value for `created_at`, must not be `None`")  # noqa: E501

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this DomainAuthProviderResponse.  # noqa: E501

        Updated Date in ISO-8601 format e.g. 2022-05-06T02:39:23.000Z  # noqa: E501

        :return: The updated_at of this DomainAuthProviderResponse.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this DomainAuthProviderResponse.

        Updated Date in ISO-8601 format e.g. 2022-05-06T02:39:23.000Z  # noqa: E501

        :param updated_at: The updated_at of this DomainAuthProviderResponse.  # noqa: E501
        :type updated_at: str
        """
        if self.local_vars_configuration.client_side_validation and updated_at is None:  # noqa: E501
            raise ValueError("Invalid value for `updated_at`, must not be `None`")  # noqa: E501

        self._updated_at = updated_at

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DomainAuthProviderResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DomainAuthProviderResponse):
            return True

        return self.to_dict() != other.to_dict()
